#pragma once

#include "gp_config.hpp"
#include "gp/function.hpp"
#include "gp/indexed_array.hpp"
#include "gp/pointers.hpp"
#include "gp/vfs/file_description.hpp"
#include "gp/vfs/platforms/platform_autopicker.hpp"

namespace gp {

	enum class process_status {
		inactive = 0,
		running = 1,
		waiting = 2,
		zombie = 3
	};

	struct process_data{
		[[no_unique_address]] gp::specifics::platform_data specifics;

		void* stack_ptr;
		void* base_ptr;
		gp::function<void()> fn;
		gp::indexed_array<gp::file_description*, gp_config::limits::max_fd_per_process> fds;
	};

}